import processing.core.*; 

import controlP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class PT_Signal2012 extends PApplet {

//INTERACTIVE VISUALIZATION OF THE PT SIGNAL, Markus Selmke (selmke@rz.uni-leipzig.de, markus.selmke@gmx.de)


ControlP5 controlP5;

/* @pjs preload="BG.jpg,Scan_RedGreen.png,Scan_Red.png,Scan_Red_PD.png,AuLens.png,AuLens_small.png,AuNP.png,AuNP_small.png,Zoom_Red.png,Zoom_Green.png,Zoom.png,PTSignalFormulaw.png,PTSignalFormulaPDw.png,PTSignalFormuladzfw.png,GreenLasers.png,RedLasers.png,Red_Beam_PT.png,Red_Beam_PTExpanded.png,Red_Beam_PTContracted.png,Signal0.png"; */

PImage bg, imGreenRed, imRed, imAuLens, imAuLens_small, imAuNP, imAuNP_small, imGreenLaser, imRedLaser;
PImage imSig, imRedPD, imDipole, imZoom, imZoomRed, imZoomGreen, imRedBeamPT, PTFormulaPD, PTFormula, PTFormuladzf;
PImage imTr, imnr, imT0, imn0, imIdz, imIhz, imRedBeamPTexpa, imRedBeamPTcontr, imPTtheta;
int Predx=0, Pgreenx=0, Plotzp=105, zpx=0, zfx=0, x=0, y=0, xp=0, ZoomPic=0, i=0, Show_LaserIntensities=0, Show_RedBIGPlot=0, Show_NPPlot=0, Show_PTAngularPlot=1;
int DichroAlpha=0, NPAlpha=0, PiezoAlpha=0, PiezoDetObj=0, PiezoIlluObj=0, ZoomAlpha=0, ZoomAlphaL=0, AlphaIlluLaser=0, AlphaDetLaser=0, SampleAlpha=0;
public int Pred=0, Pred0=0, Pgreen=0, Pgreen0=0, freq=200, Radius=40; 
public float zp=0.0f, zf=0.0f, PredFactor=0.08f, zp0=0.0f;
float zR=30.0f, fx=0.0f, Amp=0.0f, m=0.0f, fx1=0.0f, fx1n=0.0f, xp1=0.0f, yPTangular=30.0f;
int bh=20, bw=200, bx=40, Tol=50, zpScale=100, dzfScale=2;
public PFont font, CP5font;
public boolean toggleModulation=false, togglezpScan=false;
public Plot Plotgreen,Plotred,PlotredBIG;

public float[] green_numbers = new float[80];
public float[] red_numbers = new float[80];

public void setup() { 
  size(800, 800);
  smooth();
  frameRate(28);
  
  for (i=0; i<80; i++) {
    green_numbers[i] = 0.0f;
    red_numbers[i] = 0.0f;
  }
  
  // The background image must be the same size as the parameters into the size() method.
  // is 800 x 800 pixels. Load all used images.
  bg = loadImage("BG.jpg");
  imGreenRed = loadImage("Scan_RedGreen.png");
  imRed = loadImage("Scan_Red.png");
  imRedPD = loadImage("Scan_Red_PD.png");
  imAuLens = loadImage("AuLens.png");
  imAuLens_small = loadImage("AuLens_small.png");
  imAuNP = loadImage("AuNP.png");
  imAuNP_small = loadImage("AuNP_small.png");
  //imDipole = loadImage("Dipole.png");
  imZoomRed = loadImage("Zoom_Red.png");
  imZoomGreen = loadImage("Zoom_Green.png");
  imZoom = loadImage("Zoom.png");

  PTFormula = loadImage("PTSignalFormulaw.png");
  PTFormulaPD = loadImage("PTSignalFormulaPDw.png");
  PTFormuladzf = loadImage("PTSignalFormuladzfw.png");
  imTr = loadImage("Tr.png");
  imnr = loadImage("nr.png");
  imn0 = loadImage("n0.png");
  imT0 = loadImage("T0.png");
  imPTtheta = loadImage("PTtheta.png");
  imIhz = loadImage("Ihz.png");
  imIdz = loadImage("Idz.png");
  
  imGreenLaser = loadImage("GreenLasers.png");
  imRedLaser = loadImage("RedLasers.png");
  imRedBeamPT = loadImage("Red_Beam_PT.png");
  imRedBeamPTexpa = loadImage("Red_Beam_PTExpanded.png");
  imRedBeamPTcontr = loadImage("Red_Beam_PTContracted.png");

  imSig = loadImage("Signal0.png"); 
  //font = loadFont("SansSerif-12.vlw");
  font = createFont("Arial", 12); 
  textFont(font);
  
  controlP5 = new ControlP5(this);
   ControlFont CP5font = new ControlFont(font); 
   controlP5.setControlFont(CP5font);
  
  //initialize power-plots
    Plotgreen = new Plot(80, 35, 460, 700, 1);
    Plotgreen.setYData(green_numbers);
    Plotgreen.setY_Factor(0.1f);
    Plotgreen.setplot_weight(1);
    Plotgreen.setRGB(0,255,0);
    Plotgreen.setaxis_weight(1);
  
    Plotred = new Plot(80, 35, 215, 55, 1);
    Plotred.setYData(red_numbers);
    Plotred.setY_Factor(PredFactor);
    Plotred.setplot_weight(1);
    Plotred.setRGB(255,0,0);
    Plotred.setaxis_weight(1);
    
    PlotredBIG = new Plot(400, 200, 200, 500, 1);
    PlotredBIG.setYData(red_numbers);
    PlotredBIG.setY_Factor(PredFactor*200.0f/35.0f);
    PlotredBIG.setplot_weight(3);
    PlotredBIG.setRGB(255,0,0);
    PlotredBIG.setaxis_weight(2);
  
  //initialize control sliders and checkboxes
    
    Slider redslider = controlP5.addSlider("red_laser_power", 0, 255, 0, 20, 630, bw, bh);
    Slider greenslider = controlP5.addSlider("green_laser_power", 0, 255, 0, 20, 670, bw, bh);
    Slider frequencyslider = controlP5.addSlider("Frequency", 0, 1000, 0, 20+30, 700, bw-30, bh);
      frequencyslider.setValue(freq);
    Toggle modulation = controlP5.addToggle("Modulation", toggleModulation, 20, 700, 20, 20);
    
    Slider zpslider = controlP5.addSlider("particle_position", -0.5f, 0.5f, 0, 700, 145-zpScale/2, bh, zpScale);
    Toggle zpScan = controlP5.addToggle("zpScan", togglezpScan, 700, 230, 20, 20); 
    Slider dzfslider = controlP5.addSlider("focus_offset", -0.5f, 0.5f, 0, 730, 632-zpScale/2, bh, zpScale);
  
    zpslider.setNumberOfTickMarks(3);
    zpslider.showTickMarks(true);
    zpslider.snapToTickMarks(false);
    zpslider.setLabelVisible(false);
    
    dzfslider.setNumberOfTickMarks(3);
    dzfslider.showTickMarks(true);
    dzfslider.snapToTickMarks(false);
    dzfslider.setLabelVisible(false);
  
    //change their apperance!
    zpslider.captionLabel().toUpperCase(false);
    dzfslider.captionLabel().toUpperCase(false);
    zpScan.captionLabel().toUpperCase(false);
    modulation.captionLabel().toUpperCase(false);
    redslider.captionLabel().toUpperCase(false);
    greenslider.captionLabel().toUpperCase(false);
    frequencyslider.captionLabel().toUpperCase(false);
    
    zpslider.setCaptionLabel("Particle Position");
    dzfslider.setCaptionLabel("Foci Offset");
    zpScan.setCaptionLabel("zp-Scan");
  
    redslider.setColorBackground(color(255, 0, 0));
    redslider.setCaptionLabel("Laser Power");
    redslider.setColorCaptionLabel(0xffFF0000);
    //redslider.align(200,200,100,100);
    greenslider.setCaptionLabel("Laser Power");
    greenslider.setColorCaptionLabel(0xff00FF00);
    greenslider.setColorBackground(color(0, 255, 0));    
    frequencyslider.setColorBackground(color(0, 200, 0));
}

public void red_laser_power(int theValue) {
  Pred=theValue;
  Pred0=theValue;
}

public void green_laser_power(int theValue) {
  Pgreen=theValue;
  Pgreen0=theValue;
}

public void Frequency(int theValue) {
  freq=theValue;
}

public void particle_position(float theValue) {
  zp0=theValue;
}

public void focus_offset(float theValue) {
  zf=theValue;
}

public void Modulation(boolean theFlag) {
  toggleModulation=theFlag;
  if (toggleModulation==false) {
     Pgreen=Pgreen0; 
  }
}

public void zpScan(boolean theFlag) {
  togglezpScan=theFlag;
}

public void draw() 
{
  //set background image, load font, write title
    background(bg);
  
    fill(255); 
    text("click on sample to zoom in!", 15, 12);
    text("click NP to show profiles!", 15, 24);
    text("click Gaussian Beams!", 15, 36);
    frame.setTitle("PHOTOTHERMAL  SIGNAL  SIMULATOR");
    
  //laser and setup images according to Power
    strokeWeight(2);
  //red laser
    tint(255, Pred0); image(imRed, 0, 0);
    tint(255, Pred); image(imRedLaser, 370, 380);
    stroke(255, 0, 0, Pred0); 
    line(630, 632, 680, 632); //red line next to gauss

  //particle images
  //lens effect
    if (togglezpScan==true) {
       if (zp > 0.5f) {
          zp = -0.5f;
       } else { 
          zp=zp+0.01f;
          xp1=(69+round((zp+0.5f)*212)-176);
       }
    } else {
      zp=zp0;
      xp1=(69+round((zp0+0.5f)*212)-176);
    }
     
    Amp=(Pgreen0)*1.0f; 
    if (toggleModulation==true) {
      Amp = Amp*(1-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f));
    } 
    fx1 = (Amp/255.0f)*4.95f*(1/(xp1*xp1/(zR*zR)+1))*xp1/(((xp1-4*(zf)*zR)/zR)*((xp1-4*(zf)*zR)/zR)+1);
    fx1n= fx1*(Pgreen0*1.0f + (255.0f/Pred0)*randomNormal())/(Pgreen0*1.0f);
    if (fx1 <= 0) {
      tint(255, 0.8f*Pred0);
      image(imRedBeamPT, 480, -5);
      tint(255, (Pgreen/255.0f)*(Pred0/255.0f)*abs(fx1)*2); 
      image(imRedBeamPTcontr, 480, -5);
    } else {
      tint(255, (Pgreen/255.0f)*(Pred0/255.0f)*abs(fx1)*2); 
      image(imRedBeamPTexpa, 480, -5);
      tint(255, 0.8f*Pred0); 
      image(imRedBeamPT, 480, -5);
    }

  //annotate optical axis behind the big particle
    strokeWeight(2); 
    stroke(255, 50); 
    line(630, 0, 630, 290); //optical axis
    if (Show_LaserIntensities==1) {
      stroke(0,255,0,150);
      line(630-50, 145-2*zf*zR, 630+50, 145-2*zf*zR); //green beam waist
    }
    if (Pred0>0) {
      stroke(255,0,0,150); 
      line(630-50, 145, 630+50, 145); //red beam waist
    }
    stroke(255, 50); 
    line(630, 145-round(zp*zpScale), 630+70, 145-round(zp*zpScale)); //particle position 
    textAlign(CENTER, CENTER);
    fill(255); 
    rotate(PI/2); 
    text("optical axis", 255, -625); 
  //annotate detection and illumination laser at the bottom
    AlphaDetLaser = round(2550/(0.5f*(abs(mouseX - 337) + abs(mouseY - 700))+10.1f));
    fill(255,0,0, AlphaDetLaser);
    text("detection laser", 700, -355); 
    AlphaIlluLaser = round(2550/(0.5f*(abs(mouseX - 430) + abs(mouseY - 700))+10.5f));
    fill(0,255,0, AlphaIlluLaser);
    text("heating laser", 690, -445); 
    rotate(-PI/2);
    textAlign(LEFT, BASELINE) ;
  //baseline for T(r) and n(r)  
    if (Show_NPPlot==1) {
      stroke(200,0,0,100); line(630-167,144-zp*zpScale,630,143-zp*zpScale); //T_0 line
      stroke(0,200,200,150); line(630-167,146-zp*zpScale,630,147-zp*zpScale); //n_0 line
    }
  //actual big Particle images, i.e. AuNP and Hot AuNP with Lens
    tint(255, 255);
    image(imAuNP, 208, -250-round(zp*zpScale));
    if (toggleModulation==true) {
       tint(255, Pgreen/((2*zp-zf)*(2*zp-zf) + 1)*(1-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f)) + 0.7f*(Pgreen0)*exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f));
    } else {
       tint(255, Pgreen/((2*zp-zf)*(2*zp-zf) + 1));
    }  
    image(imAuLens, 208, -250-round(zp*zpScale)); 
    NPAlpha = round(255.0f*exp(-((mouseX-630)*(mouseX-630) + (mouseY-(145.0f-round(zp*zpScale)))*(mouseY-(145.0f-round(zp*zpScale))))/1000.0f));
    fill(0, NPAlpha);
    text("gold (Au)", 602, 145-round(zp*zpScale));
    text("nano-particle", 591, 157-round(zp*zpScale));
    
    //PLOT T(r) & n(r) Profile
    if (Show_NPPlot==1) {
      if (toggleModulation==true) {
        Amp = Pgreen/((2*zp-zf)*(2*zp-zf) + 1)*(1-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f)) + 0.7f*(Pgreen0)*exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f)/((2*zp-zf)*(2*zp-zf) + 1);
      } else {
        Amp = Pgreen/((2*zp-zf)*(2*zp-zf) + 1);
      }
      tint(255, 255);
      noFill(); strokeWeight(2); strokeJoin(ROUND); 
      stroke(200,0,0); 
      beginShape();
      for (x=0; x<=170; x=x+3) {
        if (x > Radius) {
          vertex(630-x,145-zp*zpScale-0.42f*Amp*Radius/x);
        } else {
          vertex(630-x,145-zp*zpScale-0.42f*Amp);
        }
      }  
      endShape();
      image(imTr, 530, 145-zp*zpScale-30-0.42f*Amp*Radius/80); //png: T(r)
      //Refractive Index Profile
      stroke(0,200,200);
      beginShape();
      for (x=0; x<=170; x=x+3) {
        if (x > Radius) {
          vertex(630-x,145-zp*zpScale+0.3f*Amp*Radius/x);
        } else {
          vertex(630-x,145-zp*zpScale+0.3f*Amp);
        }
      }  
      endShape();
      //display formulas: T_0, n_0, n(r)
      image(imnr, 530, 145-zp*zpScale+15+0.3f*Amp*Radius/80);
      image(imn0, 440, 146-zp*zpScale);
      image(imT0, 440, 130-zp*zpScale);
    }
    
    //Plot Lorenzian Laser Intensities next to Big Particle
    if (Show_LaserIntensities==1) {
      tint(255, 255);
      noFill(); strokeWeight(2); strokeJoin(ROUND);
      //I_d(z)
        stroke(255,0,0); 
        beginShape();
        for (y=-110; y<=135; y=y+2) {
          vertex(630+0.2f*Pred0/(y*y/(zR*zR)+1.0f),145+y);
        }  
        endShape();
      //I_h(z)
        stroke(0,255,0); 
        beginShape();
        for (y=-110; y<=135; y=y+2) {
          vertex(630+0.26f*Pgreen/((y+2*zf*zR)*(y+2*zf*zR)/(zR*zR)+1.0f),145+y);
        }  
        endShape();
        image(imIhz,637+0.26f*Pgreen0/((-105+2*zf*zR)*(-105+2*zf*zR)/(zR*zR)+1.0f),40);
        image(imIdz,633+0.2f*Pred0/(61*61/(zR*zR)+1.0f),61);
    }

  //plot Signal zp-Scan
  if (Pgreen0 > 0 && Pred0 > 0) {
    //arrow to plot from Photo-Diode
      strokeWeight(1); stroke(255); 
      line(204, 10, 204, 85); line(204, 10, 350, 10);
      triangle(200, 85, 200+4, 85+16, 200+8, 85);
    
    //white background for the plot
      noStroke(); fill(255, 50);
      rect(173-round(Plotzp), 122, round(2.05f*Plotzp), 278-122);
      tint(255, 255);
      image(imSig, 0, 0);
      
    //plot the PT signal angular distribution //line(630, 0, 630, 290); //optical axis
    if (Show_PTAngularPlot==1) {
      tint(255, 255); 
      image(imPTtheta, 630+110, 10); //displays Phi(theta) formula
      //fill(255);
      //text("rel. PT signal", 710, yPTangular-6);
      //text("(angular distribution)", 675, yPTangular+15);
      strokeWeight(1.0f); strokeJoin(ROUND); noFill();
      beginShape();
      for (x=630-120; x<=630+120; x=x+1) {
        xp=(x-630);
        Amp=Pgreen0*1.0f + 0.5f*(255.0f/Pred0)*randomNormal();
        if (toggleModulation==true) {
          Amp = Amp*(1-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f));
        }
        fx=50.0f*(Amp/255.0f)*signum(fx1)*(exp(-xp*xp/1500.0f)-0.6f*exp(-xp*xp/3000.0f));
        if (fx>0) {
          stroke(255, 0, 0); 
          line(x, yPTangular, x, yPTangular+fx); 
          stroke(0); 
          vertex(x, yPTangular+fx);
        } else {
          stroke(0, 0, 255); 
          line(x, yPTangular, x, yPTangular+fx); 
          stroke(0); 
          vertex(x, yPTangular+fx);
        }
      }
      endShape();
    }
    //plot the PT signal zp-scan 
      strokeWeight(1.0f); strokeJoin(ROUND); noFill();
      beginShape();
      for (x=69; x<=283; x=x+1) {
        xp=(x-176);
        Amp=Pgreen0*1.0f + 1.0f*(255.0f/Pred0)*randomNormal();
        if (toggleModulation==true) {
          Amp = Amp*(1-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f));
        }
        fx=(Amp/(255))*4.95f*(1/(xp*xp/(zR*zR)+1))*xp/(((xp-4*zf*zR)/zR)*((xp-4*zf*zR)/zR)+1);
        if (fx>0) {
          stroke(255, 0, 0); 
          line(x, 202, x, 202+fx); 
          stroke(0); 
          vertex(x, 202+fx);
        } else {
          stroke(0, 0, 255); 
          line(x, 200, x, 200+fx); 
          stroke(0); 
          vertex(x, 200+fx);
        }
      }
      endShape();
    //plot PT Signal-points into plot
      stroke(255, 140, 0, 200); 
      ellipseMode(CENTER); 
      fill(255, 140, 0); 
      ellipse(67, 200+fx1n, 5, 5); 
      ellipse(xp1+176, 200+fx1n, 5, 5);    
    //plot zp-vertical line into plot
      stroke(255, 160, 0, 150); 
      strokeWeight(2);
      line(175+round(2*zp*Plotzp), 122, 175+round(2*zp*Plotzp), 278);
    //formula for PT signal, phi=Delta P_d/P_d
      image(PTFormula, 90, 25, 100, 100);
  }

  //Red signal channel, i.e. red beam behind collection objective 
    tint(255, Pred); 
    image(imRedPD, 0, 0);
    
  //green laser
    strokeWeight(2);
    tint(255, Pgreen);
    image(imGreenRed, 0, 0); 
    image(imGreenLaser, 350, 380-round(zf*zpScale));
    stroke(0, 255, 0, Pgreen0); 
    line(610, 632-round(zf*zpScale), 680, 632-round(zf*zpScale)); //green line next to gauss focus
    stroke(0, 255, 0, Pgreen0*0.5f); 
    line(680, 632-round(zf*zpScale), 730, 632-round(zf*zpScale)); //green line next to gauss focus to slider
    
  //ZoomBox
    //ZoomAlpha = round(2550/(0.5*(abs(mouseX - 385) + abs(mouseY - 395))+10.5));
    ZoomAlpha = round(255*exp(-((mouseX - 385)*(mouseX - 385) + (mouseY - 395)*(mouseY - 395))/150.0f));
    stroke(255, 140, 0, ZoomAlpha); 
    strokeWeight(2); 
    noFill();
    rect(350, 360, 70, 70);
    rect(500, 20, 250, 250);
    line(350, 360, 500, 20);
    line(420, 430, 750, 270);

  //LaserZoomBox
    ZoomAlphaL = round(255*exp(-((mouseX - 620)*(mouseX - 620) + (mouseY - 630)*(mouseY - 630))/400.0f));
    stroke(255, 160, 0, ZoomAlphaL); 
    strokeWeight(2); 
    noFill();
    rect(350, 360, 70, 70);
    rect(490, 450, 250, 300);
    line(350, 430, 490, 750);
    line(420, 360, 740, 450);

  //Foci-Offset
    fill(255, Pgreen0); 
    stroke(255, Pgreen0); 
    tint(255, Pgreen0);
    strokeWeight(2); 
    line(660, 632, 660, 632-round(zf*zpScale));
    //arrow and dzf formula
    if (zf<0) {
      noStroke(); 
      triangle(660-5, 632-round(zf*zpScale)-8, 660+5, 632-round(zf*zpScale)-8, 660, 632-round(zf*zpScale));
      image(PTFormuladzf, 660, 620-25-round(zf*zpScale), 50, 50);
    } else {
      noStroke(); 
      triangle(660-5, 632-round(zf*zpScale)+8, 660+5, 632-round(zf*zpScale)+8, 660, 632-round(zf*zpScale));
      image(PTFormuladzf, 660, 620-5-round(zf*zpScale), 50, 50);
    }

  //Photo-Diode
    fill(0); noStroke(); 
    rect(353, 0, 50, 15);
    fill(255); 
    text("Photo-Diode", 409, 14);
  //arrow to PT plot
    tint(255, 255); 
    image(PTFormulaPD, 420, 16, 30, 30); //formula

  DichroAlpha = round(2550/(0.5f*(abs(mouseX - (345+30)) + abs(mouseY - 78))+10.5f));
  fill(255, DichroAlpha); 
  text("dichroic filter", 345, 78);    
  PiezoAlpha = round(2550/(0.5f*(abs(mouseX - (120+30)) + abs(mouseY - 400))+10.5f));
  fill(255, PiezoAlpha); 
  text("piezo scanner", 120, 400);
  PiezoDetObj = round(2550/(0.5f*(abs(mouseX - (328+50)) + abs(mouseY - 200))+10.5f));
  fill(0, PiezoDetObj); 
  text("detection objective", 328, 200);
  PiezoIlluObj = round(2550/(0.5f*(abs(mouseX - (324+50)) + abs(mouseY - 601))+10.2f));
  fill(0, PiezoIlluObj); 
  text("illumination objective", 324, 601);
  SampleAlpha = round(2550/(0.5f*(abs(mouseX - (364+20)) + abs(mouseY - 400))+10.2f));
  fill(0, SampleAlpha); 
  text("sample", 373, 420);

  //Zoom-Image
  if (ZoomPic==1) {
    tint(255, 255); 
    image(imZoom, 50, 10);
    tint(255, 0.7f*Pgreen); 
    image(imZoomGreen, 50, 10);
    tint(255, 0.7f*Pred0); 
    image(imZoomRed, 50, 10);
    stroke(0, 50); 
    strokeWeight(2); 
    noFill(); 
    rect(50, 10, 600, 600); //boundary
    //particle
    tint(255, 255); 
    //image(imAuNP, 315, 297-round(2*(zp)*10), 70, 70);
    image(imAuNP_small, 315, 297-round(2*zp*10)); 
    if (toggleModulation==true) {
       tint(255, Pgreen*(1.0f-exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f)) + 0.7f*(Pgreen0)*exp(-(freq-1000.0f)*(freq-1000.0f)/10000.0f));
    } else {
       tint(255, Pgreen);
    }  
    //image(imAuLens, 315, 297-round(2*(zp)*10), 70, 70);
    image(imAuLens_small, 315, 297-round(2*zp*10));
  }

  //if Mod is on: Modulate Pgreen and Pred accordingly
  if (toggleModulation) {
     Pgreen=round(Pgreen0*0.5f*(1.0f+sin(m*2*PI*freq/4000.0f))); 
     Pred=round(Pred0 - (Pred0/255.0f)*2.5f*fx1*0.5f*(1.0f+sin(m*2*PI*freq/4000.0f)));
  } else {
     Pred=round(Pred0 - (Pred0/255.0f)*2.5f*fx1);
  }
    
  //plot powers over time
    //background line for red laser
      stroke(255, 0, 0, 200); strokeWeight(1); 
      line(215, 55-PredFactor*Pred0, 295, 55-PredFactor*Pred0); //constant background level
    
    //draw plots
      m = m+1;//millis();
      Plotgreen.run();
      Plotred.run();
   
    //move plot
      for (int i = 1; i<green_numbers.length;i++) {
        green_numbers[i-1] = green_numbers[i];
        red_numbers[i-1] = red_numbers[i];
      }
      green_numbers[green_numbers.length-1]=Pgreen;
      red_numbers[red_numbers.length-1]=Pred;
      
      
   if (Show_RedBIGPlot==1) {
     //setup line: PlotredBIG = new Plot(xsize: 400, ysize: 200, xorigin: 200, yorigin: 500, 1);
     noStroke(); fill(255, 150);
     rect(200, 300, 400, 200);
     fill(255,0,0);
     text("Detected Photo-Diode Signal: Transmitted red laser Power", 220, 315);
     stroke(255, 0, 0, 200); strokeWeight(2); 
     line(200, 500-PredFactor*Pred0*200.0f/35.0f, 600, 500-PredFactor*Pred0*200.0f/35.0f); //constant background level
     PlotredBIG.run();
   }
  
   //anotate sliders    
    fill(255);
    text("Particle Position", 700, 210);
    text("Foci Offset", 730, 700);
  //end of draw
}

//Toggle Zoom-Image
public void mousePressed() {
  if (ZoomPic == 1) {
    if (mouseX > 50 && mouseX < 50+600 && mouseY > 10 && mouseY < 10+600) {
      ZoomPic = 0;
    }
  } else {
    if (mouseX > 385-Tol && mouseX < 385+Tol && mouseY > 395-Tol && mouseY < 395+Tol) {
      ZoomPic = 1;
    }
  }
  
  //plot bigger Graph original small plot at Plot(80, 35, 215, 55, 1);
  if (Show_RedBIGPlot == 1) {
    if (mouseX > 215 && mouseX < 215+80 && mouseY > 55-35 && mouseY < 55) {
      Show_RedBIGPlot = 0;
    } else if (mouseX > 200 && mouseX < 600 && mouseY > 300 && mouseY < 500) {
      Show_RedBIGPlot = 0;
    }
  } else {
    if (mouseX > 215 && mouseX < 215+80 && mouseY > 55-35 && mouseY < 55) {
      Show_RedBIGPlot = 1;
    }
  }
  
  //plot bigger Graph original small plot at x=602, y=145-round(2*zp*30)
  if (Show_NPPlot == 1) {
    if (mouseX > 630-Radius && mouseX < 630+Radius && mouseY > 145-Radius-round(zp*zpScale) && mouseY < 145+Radius-round(zp*zpScale)) {
      Show_NPPlot = 0;
    }
  } else {
    if (mouseX > 630-Radius && mouseX < 630+Radius && mouseY > 145-Radius-round(zp*zpScale) && mouseY < 145+Radius-round(zp*zpScale)) {
      Show_NPPlot = 1;
    }
  }
  
  //plot PT signals Angular Distribution!
  if (Show_PTAngularPlot == 1) {
    if (mouseX > 630-120 && mouseX < 630+120 && mouseY > yPTangular-20 && mouseY < yPTangular+20) {
      Show_PTAngularPlot = 0;
    }
  } else {
    if (mouseX > 630-120 && mouseX < 630+120 && mouseY > yPTangular-20 && mouseY < yPTangular+20) {
      Show_PTAngularPlot = 1;
    }
  }
  
  //plot Laser Intensities on top of Big Particle! Laser Zoom-Box: rect(490, 450, 250, 300);
  if (Show_LaserIntensities == 1) {
    if (mouseX > 490+80 && mouseX < 490+190 && mouseY > 450 && mouseY < 450+300) {
      Show_LaserIntensities = 0;
    }
  } else {
    if (mouseX > 490+80 && mouseX < 490+190 && mouseY > 450 && mouseY < 450+300) {
      Show_LaserIntensities = 1;
    }
  }

}

// return a random value in the range [-1..1] with normal distribution around 0.
// Implements the Marsaglia Polar Method, as described in wikipedia, but only returns one of the values.
public float randomNormal()
{
  float x = 1.0f, y = 1.0f, 
        s = 2.0f; // s = x^2 + y^2
  while(s >= 1.0f)
  {
    x = random(-1.0f, 1.0f);
    y = random(-1.0f, 1.0f);
    s = x*x + y*y;
  }
  return x * sqrt(-2.0f * log(s)/s);
}

public float signum(float f) {
  if (f > 0) return 1.0f;
  if (f < 0) return -1.0f;
  return 0;
} 
public class Plot {

  int xsize;
  int ysize;
  int x_origin;
  int y_origin;
  int type;
  int plot_weight;
  int R, G, B;
  float y_factor;
  float y_offset;

  int axis_weight=1;
  float[] xdata;
  float[] ydata;

  Plot(int xs, int ys, int xo, int yo, int _type) {
    xsize=xs;
    ysize=ys;
    x_origin=xo;
    y_origin=yo;
    type=_type;
    y_factor=1;
    y_offset=0;
  }


  public void run() {
    drawData();
    drawAxis();    
    render();
  }

  public void setYData(float[] d) {
    ydata = new float[d.length];
    ydata=d;
  }
  
  
  public void setY_Factor(float _f) {
    y_factor=_f;
  }
  
  public void setplot_weight(int _plot_weightV) {
    plot_weight=_plot_weightV;
  }
  
  
  public void setaxis_weight(int _axis_weightV) {
    axis_weight=_axis_weightV;
  }
  
  

  public void setRGB(int _Rv, int _Gv, int _Bv) {
    R=_Rv;
    G=_Gv;
    B=_Bv;
  }

  public void setY_Offset(float _f) {
    y_offset=_f;
  }


  public void setXData(float[] d) {
    xdata = new float[d.length];
    xdata=d;
  }

  public void drawAxis() {
    stroke(255);
    strokeWeight(axis_weight);
    line(x_origin, y_origin, x_origin+xsize, y_origin);
    line(x_origin+xsize-3, y_origin+2, x_origin+xsize, y_origin);
    line(x_origin+xsize-3, y_origin-2, x_origin+xsize, y_origin);
    line(x_origin, y_origin, x_origin, y_origin-ysize);
    line(x_origin+2, y_origin-ysize+3, x_origin, y_origin-ysize);
    line(x_origin-2, y_origin-ysize+3, x_origin, y_origin-ysize);
  }

  public void drawData() {

    stroke(0);
    noFill();

    if (type==1) {
      beginShape();
      stroke(R, G, B); 
      strokeWeight(plot_weight);
      noFill();
      for (int i = 0; i<ydata.length;i++) {
        vertex(i*xsize/ydata.length+x_origin, y_origin-ydata[i]*y_factor);
      }
      endShape();
    }
    
    if (type==2) {
      beginShape();
      for (int i = 0; i<ydata.length;i++) {
        vertex(xdata[i]+x_origin, y_origin-ydata[i]*y_factor);
      }
      endShape();
    }
  }

  public void render() {
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "PT_Signal2012" });
  }
}
